function out = compute_and_find_max_values(finalmat,iterations)

finalmat = compute_errors_color(finalmat,'ALL',iterations+1); % EDGE / ALL / INTRAREGION

for i_std = 1:size(finalmat,1)
    for i_img = 1:size(finalmat,2)
        for i_method = 1:(size(finalmat{1,1},2)-2)
            [val pos] = max(finalmat{i_std,i_img}{i_method}.ssim);

            max_ssim_val(i_std,i_method,i_img) = val;
            max_ssim_pos(i_std,i_method,i_img) = pos;

            [val pos] = max(finalmat{i_std,i_img}{i_method}.psnr);
            max_psnr_val(i_std,i_method,i_img) = val;
            max_psnr_pos(i_std,i_method,i_img) = pos;
        end
    end
end


out = finalmat;
for i_std = 1:size(finalmat,1)
    for i_img = 1:size(finalmat,2)
        for i_method = 1:(size(finalmat{1,1},2)-2)
            data = finalmat{i_std,i_img}{i_method};
            
            data.umax_ssim = data.images(:,:,:,max_ssim_pos(i_std,i_method));
            data.umax_psnr = data.images(:,:,:,max_psnr_pos(i_std,i_method));
            
            data.images = [];
            out{i_std,i_img}{i_method} = data;
        end
    end
end

end