function finalmat = compute_errors_color(finalmat,weight_method,N)

[n_std n_img] = size(finalmat);
n_alg = size(finalmat{1,1},2)-2;

for i_std = 1:n_std
    for i_img = 1:n_img
        
        u0 = finalmat{1,i_img}{1}.u0;
        
        switch weight_method
            case 'EDGE'
                [gx gy gxx gxy gyy w wd wdd] = filters('OPT gauss','2D','1st 2nd',1);
                
                for c = 1:3
                    uref = extendImg(u0(:,:,c));
                    ux  = conv2(uref,gx,'valid');
                    uy  = conv2(uref,gy,'valid');
                    gradu = sqrt(ux.^2 + uy.^2);
                    weight(:,:,c)  = conv2(w,w,gradu,'same');
                end
            case 'ALL'
                weight = true(size(u0));
            case 'INTRAREGION'
                [gx gy gxx gxy gyy w wd wdd] = filters('OPT gauss','2D','1st 2nd',1);
                for c = 1:3
                    uref = extendImg(u0(:,:,c));
                    ux  = conv2(uref,gx,'valid');
                    uy  = conv2(uref,gy,'valid');
                    gradu = sqrt(ux.^2 + uy.^2);
                    edgeweight(:,:,c)  = conv2(w,w,gradu,'same');
                end
                 weight = true(size(u0)) - edgeweight;
        end
        
        for i_alg = 1:n_alg
            data = finalmat{i_std,i_img}{i_alg};
            ndim = size(data.images(:,:,:,1),3);
            Nimg = size(data.images,4);
            
            if isempty(Nimg)
                Nimg = size(data.images,4);
            end
            
            ssimvec    = nan(N,ndim);
            psnrvec    = nan(N,ndim);
            for c = 1:ndim
                for n = 1:Nimg
                    ssimvec(n,c)    = error_ssim(data.u0(:,:,c),data.images(:,:,c,n),weight(:,:,c));
                    psnrvec(n,c)    = error_psnr(data.u0(:,:,c),data.images(:,:,c,n),weight(:,:,c));
                end
            end
            
            data.psnr = sum(psnrvec,2)/ndim;
            data.ssim = sum(ssimvec,2)/ndim;
            finalmat{i_std,i_img}{i_alg} = data;
        end
    end
end
