function D = remapp_eigenvalues_nonsymmetric_alg(T,K)

% Computed with
% syms a b c d k;
% simplify(expm(k*[a b; c d]))

D = zeros(size(T));

a = T(:,:,1);
b = T(:,:,2);
c = T(:,:,3);
d = T(:,:,4);

const = 1e-3;
k = -1./sqrt(K^2 + const^2);

D11 = (c.*exp((a.*k)./2 + (d.*k)./2 - (k.*(a.^2 - 2.*a.*d + d.^2 + 4.*b.*c).^(1./2))./2).*(d./c - ((a.*k)./2 + (d.*k)./2 - (k.*(a.^2 - 2.*a.*d + d.^2 + 4.*b.*c).^(1./2))./2)./(c.*k)))./(a.^2 - 2.*a.*d + d.^2 + 4.*b.*c).^(1./2) - (c.*exp((a.*k)./2 + (d.*k)./2 + (k.*(a.^2 - 2.*a.*d + d.^2 + 4.*b.*c).^(1./2))./2).*(d./c - ((a.*k)./2 + (d.*k)./2 + (k.*(a.^2 - 2.*a.*d + d.^2 + 4.*b.*c).^(1./2))./2)./(c.*k)))./(a.^2 - 2.*a.*d + d.^2 + 4.*b.*c).^(1./2);
D12 = (2.*b.*exp((a.*k)./2).*exp((d.*k)./2).*sinh((k.*(a.^2 - 2.*a.*d + d.^2 + 4.*b.*c).^(1./2))./2))./(a.^2 - 2.*a.*d + d.^2 + 4.*b.*c).^(1./2);
D21 = (2.*c.*exp((a.*k)./2).*exp((d.*k)./2).*sinh((k.*(a.^2 - 2.*a.*d + d.^2 + 4.*b.*c).^(1./2))./2))./(a.^2 - 2.*a.*d + d.^2 + 4.*b.*c).^(1./2);
D22 = (exp((a.*k)./2 + (d.*k)./2 - (k.*(a.^2 - 2.*a.*d + d.^2 + 4.*b.*c).^(1./2))./2).*(a - d + (a.^2 - 2.*a.*d + d.^2 + 4.*b.*c).^(1./2)))./(2.*(a.^2 - 2.*a.*d + d.^2 + 4.*b.*c).^(1./2)) + (exp((a.*k)./2 + (d.*k)./2 + (k.*(a.^2 - 2.*a.*d + d.^2 + 4.*b.*c).^(1./2))./2).*(d - a + (a.^2 - 2.*a.*d + d.^2 + 4.*b.*c).^(1./2)))./(2.*(a.^2 - 2.*a.*d + d.^2 + 4.*b.*c).^(1./2));

D(:,:,1) = D11;
D(:,:,2) = D12;
D(:,:,3) = D21;
D(:,:,4) = D22;










